Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Views/3.4/BenchmarkGeneratorDialog.Designer.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Views/3.4/BenchmarkGeneratorDialog.Designer.cs	(revision 7308)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Views/3.4/BenchmarkGeneratorDialog.Designer.cs	(revision 7308)
@@ -0,0 +1,110 @@
+﻿namespace HeuristicLab.Problems.DataAnalysis.Views {
+  partial class BenchmarkGeneratorDialog {
+    /// <summary>
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary>
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Windows Form Designer generated code
+
+    /// <summary>
+    /// Required method for Designer support - do not modify
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.cancelButton = new System.Windows.Forms.Button();
+      this.okButton = new System.Windows.Forms.Button();
+      this.BenchmarkGeneratorListView = new System.Windows.Forms.ListView();
+      this.NameColumnHeader = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
+      this.DescriptionColumnHeader = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
+      this.SuspendLayout();
+      // 
+      // cancelButton
+      // 
+      this.cancelButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.cancelButton.DialogResult = System.Windows.Forms.DialogResult.Cancel;
+      this.cancelButton.Location = new System.Drawing.Point(537, 409);
+      this.cancelButton.Name = "cancelButton";
+      this.cancelButton.Size = new System.Drawing.Size(75, 23);
+      this.cancelButton.TabIndex = 5;
+      this.cancelButton.Text = "&Cancel";
+      this.cancelButton.UseVisualStyleBackColor = true;
+      // 
+      // okButton
+      // 
+      this.okButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.okButton.DialogResult = System.Windows.Forms.DialogResult.OK;
+      this.okButton.Enabled = false;
+      this.okButton.Location = new System.Drawing.Point(456, 409);
+      this.okButton.Name = "okButton";
+      this.okButton.Size = new System.Drawing.Size(75, 23);
+      this.okButton.TabIndex = 4;
+      this.okButton.Text = "&OK";
+      this.okButton.UseVisualStyleBackColor = true;
+      this.okButton.Click += new System.EventHandler(this.okButton_Click);
+      // 
+      // BenchmarkGeneratorListView
+      // 
+      this.BenchmarkGeneratorListView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.BenchmarkGeneratorListView.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
+            this.NameColumnHeader,
+            this.DescriptionColumnHeader});
+      this.BenchmarkGeneratorListView.FullRowSelect = true;
+      this.BenchmarkGeneratorListView.HideSelection = false;
+      this.BenchmarkGeneratorListView.Location = new System.Drawing.Point(12, 12);
+      this.BenchmarkGeneratorListView.MultiSelect = false;
+      this.BenchmarkGeneratorListView.Name = "BenchmarkGeneratorListView";
+      this.BenchmarkGeneratorListView.Size = new System.Drawing.Size(600, 391);
+      this.BenchmarkGeneratorListView.TabIndex = 6;
+      this.BenchmarkGeneratorListView.UseCompatibleStateImageBehavior = false;
+      this.BenchmarkGeneratorListView.View = System.Windows.Forms.View.Details;
+      this.BenchmarkGeneratorListView.SelectedIndexChanged += new System.EventHandler(this.BenchmarkGeneratorListView_SelectedIndexChanged);
+      this.BenchmarkGeneratorListView.DoubleClick += new System.EventHandler(this.BenchmarkGeneratorListView_DoubleClick);
+      // 
+      // NameColumnHeader
+      // 
+      this.NameColumnHeader.Text = "Name";
+      this.NameColumnHeader.Width = 100;
+      // 
+      // DescriptionColumnHeader
+      // 
+      this.DescriptionColumnHeader.Text = "Description";
+      // 
+      // BenchmarkGeneratorDialog
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.ClientSize = new System.Drawing.Size(624, 444);
+      this.Controls.Add(this.BenchmarkGeneratorListView);
+      this.Controls.Add(this.cancelButton);
+      this.Controls.Add(this.okButton);
+      this.Name = "BenchmarkGeneratorDialog";
+      this.Text = "Select Benchmark Problem";
+      this.Load += new System.EventHandler(this.NewItemDialog_Load);
+      this.Shown += new System.EventHandler(this.NewItemDialog_Shown);
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Button cancelButton;
+    private System.Windows.Forms.Button okButton;
+    private System.Windows.Forms.ListView BenchmarkGeneratorListView;
+    private System.Windows.Forms.ColumnHeader NameColumnHeader;
+    private System.Windows.Forms.ColumnHeader DescriptionColumnHeader;
+  }
+}
Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Views/3.4/BenchmarkGeneratorDialog.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Views/3.4/BenchmarkGeneratorDialog.cs	(revision 7308)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Views/3.4/BenchmarkGeneratorDialog.cs	(revision 7308)
@@ -0,0 +1,108 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections;
+using System.Collections.Generic;
+using System.Linq;
+using System.Windows.Forms;
+using HeuristicLab.Common;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Problems.DataAnalysis.Views {
+  internal partial class BenchmarkGeneratorDialog : Form {
+    private bool initialized;
+
+    private IDataAnalysisProblem Content;
+
+    private IDataAnalysisProblemData problemData;
+    public IDataAnalysisProblemData ProblemData {
+      get {
+        return problemData;
+      }
+    }
+
+    public BenchmarkGeneratorDialog(IDataAnalysisProblem Content) {
+      initialized = false;
+      InitializeComponent();
+      this.Content = Content;
+    }
+
+    private void NewItemDialog_Load(object sender, EventArgs e) {
+      if (!initialized) {
+        IEnumerable<IDataAnalysisBenchmarkProblemDataGenerator> generators = new List<IDataAnalysisBenchmarkProblemDataGenerator>();
+        if (Content is IRegressionProblem)
+          generators = ApplicationManager.Manager.GetInstances<IRegressionBenchmarkProblemDataGenerator>();
+        else if (Content is IClassificationProblem)
+          generators = ApplicationManager.Manager.GetInstances<IClassificationBenchmarkProblemDataGenerator>();
+        else if (Content is IClusteringProblem)
+          generators = ApplicationManager.Manager.GetInstances<IClusteringBenchmarkProblemDataGenerator>();
+
+        IOrderedEnumerable<IDataAnalysisBenchmarkProblemDataGenerator> bla = generators.OrderBy(b => b.Name, new NaturalStringComparer());
+
+        foreach (var generator in bla) {
+          ListViewItem item = new ListViewItem(new string[] { generator.Name, generator.Description });
+          item.Tag = generator;
+          BenchmarkGeneratorListView.Items.Add(item);
+        }
+
+        BenchmarkGeneratorListView.ListViewItemSorter = new ListViewItemComparer();
+
+        for (int i = 0; i < BenchmarkGeneratorListView.Columns.Count; i++)
+          BenchmarkGeneratorListView.Columns[i].AutoResize(ColumnHeaderAutoResizeStyle.ColumnContent);
+
+        initialized = true;
+      }
+    }
+
+    private void NewItemDialog_Shown(object sender, EventArgs e) {
+      problemData = null;
+    }
+
+    private void BenchmarkGeneratorListView_SelectedIndexChanged(object sender, EventArgs e) {
+      okButton.Enabled = BenchmarkGeneratorListView.SelectedItems.Count == 1;
+    }
+
+    private void okButton_Click(object sender, EventArgs e) {
+      if (BenchmarkGeneratorListView.SelectedItems.Count == 1) {
+        problemData = ((IDataAnalysisBenchmarkProblemDataGenerator)BenchmarkGeneratorListView.SelectedItems[0].Tag).GenerateProblemData();
+        DialogResult = DialogResult.OK;
+        Close();
+      }
+    }
+
+    private void BenchmarkGeneratorListView_DoubleClick(object sender, EventArgs e) {
+      if (BenchmarkGeneratorListView.SelectedItems.Count == 1) {
+        problemData = ((IDataAnalysisBenchmarkProblemDataGenerator)BenchmarkGeneratorListView.SelectedItems[0].Tag).GenerateProblemData();
+        DialogResult = DialogResult.OK;
+        Close();
+      }
+    }
+
+    private class ListViewItemComparer : IComparer {
+      private NaturalStringComparer comp = new NaturalStringComparer();
+
+      public int Compare(object x, object y) {
+        return comp.Compare(((ListViewItem)x).SubItems[0].Text, ((ListViewItem)y).SubItems[0].Text);
+      }
+    }
+  }
+}
Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Views/3.4/BenchmarkGeneratorDialog.resx
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Views/3.4/BenchmarkGeneratorDialog.resx	(revision 7308)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Views/3.4/BenchmarkGeneratorDialog.resx	(revision 7308)
@@ -0,0 +1,120 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<root>
+  <!-- 
+    Microsoft ResX Schema 
+    
+    Version 2.0
+    
+    The primary goals of this format is to allow a simple XML format 
+    that is mostly human readable. The generation and parsing of the 
+    various data types are done through the TypeConverter classes 
+    associated with the data types.
+    
+    Example:
+    
+    ... ado.net/XML headers & schema ...
+    <resheader name="resmimetype">text/microsoft-resx</resheader>
+    <resheader name="version">2.0</resheader>
+    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
+    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
+    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
+    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
+    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
+        <value>[base64 mime encoded serialized .NET Framework object]</value>
+    </data>
+    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
+        <comment>This is a comment</comment>
+    </data>
+                
+    There are any number of "resheader" rows that contain simple 
+    name/value pairs.
+    
+    Each data row contains a name, and value. The row also contains a 
+    type or mimetype. Type corresponds to a .NET class that support 
+    text/value conversion through the TypeConverter architecture. 
+    Classes that don't support this are serialized and stored with the 
+    mimetype set.
+    
+    The mimetype is used for serialized objects, and tells the 
+    ResXResourceReader how to depersist the object. This is currently not 
+    extensible. For a given mimetype the value must be set accordingly:
+    
+    Note - application/x-microsoft.net.object.binary.base64 is the format 
+    that the ResXResourceWriter will generate, however the reader can 
+    read any of the formats listed below.
+    
+    mimetype: application/x-microsoft.net.object.binary.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
+            : and then encoded with base64 encoding.
+    
+    mimetype: application/x-microsoft.net.object.soap.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
+            : and then encoded with base64 encoding.
+
+    mimetype: application/x-microsoft.net.object.bytearray.base64
+    value   : The object must be serialized into a byte array 
+            : using a System.ComponentModel.TypeConverter
+            : and then encoded with base64 encoding.
+    -->
+  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
+    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
+    <xsd:element name="root" msdata:IsDataSet="true">
+      <xsd:complexType>
+        <xsd:choice maxOccurs="unbounded">
+          <xsd:element name="metadata">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" />
+              </xsd:sequence>
+              <xsd:attribute name="name" use="required" type="xsd:string" />
+              <xsd:attribute name="type" type="xsd:string" />
+              <xsd:attribute name="mimetype" type="xsd:string" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="assembly">
+            <xsd:complexType>
+              <xsd:attribute name="alias" type="xsd:string" />
+              <xsd:attribute name="name" type="xsd:string" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="data">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
+              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
+              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="resheader">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" />
+            </xsd:complexType>
+          </xsd:element>
+        </xsd:choice>
+      </xsd:complexType>
+    </xsd:element>
+  </xsd:schema>
+  <resheader name="resmimetype">
+    <value>text/microsoft-resx</value>
+  </resheader>
+  <resheader name="version">
+    <value>2.0</value>
+  </resheader>
+  <resheader name="reader">
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <resheader name="writer">
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+</root>
Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj	(revision 7307)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj	(revision 7308)
@@ -158,4 +158,10 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="BenchmarkGeneratorDialog.cs">
+      <SubType>Form</SubType>
+    </Compile>
+    <Compile Include="BenchmarkGeneratorDialog.Designer.cs">
+      <DependentUpon>BenchmarkGeneratorDialog.cs</DependentUpon>
+    </Compile>
     <Compile Include="Classification\ClassificationEnsembleSolutionEstimatedClassValuesView.cs">
       <SubType>UserControl</SubType>
@@ -341,4 +347,7 @@
   </ItemGroup>
   <ItemGroup>
+    <EmbeddedResource Include="BenchmarkGeneratorDialog.resx">
+      <DependentUpon>BenchmarkGeneratorDialog.cs</DependentUpon>
+    </EmbeddedResource>
     <EmbeddedResource Include="DataAnalysisProblemView.resx">
       <DependentUpon>DataAnalysisProblemView.cs</DependentUpon>